
CREATE TABLE sk_system_conf (
  conf_id integer PRIMARY KEY,
  "type" integer NOT NULL default '0' CHECK ("type" >= 0),
  attribute TEXT NOT NULL default '',
  value TEXT NOT NULL default '',
  provider_id integer NOT NULL default '0' CHECK (provider_id >= 0),
  service_id integer NOT NULL DEFAULT '0' CHECK (service_id >= 0),
  obj_id integer NOT NULL default '0' CHECK (obj_id >= 0),
  active TEXT NOT NULL default 'Y' CHECK (active = 'Y' OR active = 'N')
);

CREATE TABLE sk_history (
  "date_time" text not null default (datetime('now')),
  "type" integer NOT NULL DEFAULT '0',
  access_from text,
  access_to text,
  auth_name text,
  auth_info text,
  "comment" text
);
