<?php
 function MYUI_pie_chart_helper( $name='', $title='', $values=array()) { $labels = array(); $data = array(); $pcolors = array( 0=>'rgba(64,192,64,0.7)', 1=>'rgba(64,255,64,0.7)', 2=>'rgba(128,255,128,0.7)', 3=>'rgba(192,255,192,0.7)', 4=>'rgba(192,64,64,0.7)', 5=>'rgba(255,64,64,0.7)', 6=>'rgba(255,128,128,0.7)', 7=>'rgba(255,192,192,0.7)', 8=>'rgba(64,64,192,0.7)', 9=>'rgba(64,64,255,0.7)', 10=>'rgba(128,128,255,0.7)', 11=>'rgba(192,192,255,0.7)' ); $colors = array(); for ( $i = 0; $i < count( $values); $i ++) { $labels[] = "'".$values[$i][0]."'"; $data[] = $values[$i][1]; $colors[] = isset($pcolors[$i])? $pcolors[$i] :"rgba(".rand(0,255).",".rand(0,255).",".rand(0,255).", 0.7)"; } $ctx = '
<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.7.3/Chart.min.js" type="text/javascript"></script>
<div class="card">
<div class="card-header">
<div class="card-title h5">'.$title.'</div>
</div>
<div class="card-body">
<canvas id="'.$name.'_area"></canvas></div></div>
<script type="text/javascript">
//![CDATA[
var cfg_'.$name." = {
	type: 'pie',
	data: {
	    datasets: [{
		data: ".json_encode($data).",
		backgroundColor: ".json_encode($colors).",
		label: '".$title."'
	    }],
	    labels: ".json_encode($labels)."
	},
	options: {
	    responsive: true
	}
};

var ctx = document.getElementById('".$name."_area').getContext('2d');
var my_".$name."_Pie = new Chart(ctx, cfg_".$name.");

//]]</script>"; return $ctx; } function MYUI_column_chart_helper( $name='', $title='', $values=array()) { if (!is_array($values) || (count($values) < 2)) return ''; $pcolors = array( 0=>'rgba(64,64,192,0.7)', 1=>'rgba(64,64,255,0.7)', 2=>'rgba(128,128,255,0.7)', 3=>'rgba(192,192,255,0.7)', 4=>'rgba(192,64,64,0.7)', 5=>'rgba(255,64,64,0.7)', 6=>'rgba(255,128,128,0.7)', 7=>'rgba(255,192,192,0.7)', 8=>'rgba(64,192,64,0.7)', 9=>'rgba(64,255,64,0.7)', 10=>'rgba(128,255,128,0.7)', 11=>'rgba(192,255,192,0.7)' ); reset($values[0]); $label_field = ''; $data = array(); $i = 0; foreach($values[0] as $k=>$v) { if (empty($v)) $label_field = $k; else { $data[$k] = array('label' => $v, 'color' => (isset($pcolors[$i])?$pcolors[$i]:'rgba('.rand(0,255).', '.rand(0,255).', '.rand(0,255).', 0.7)'), 'data' => array()); $i ++; } } if (empty($label_field) || (count($data) < 1)) return ''; $lables = array(); for ($i = 1; $i < count($values); $i ++) { if (empty($values[$i][$label_field])) continue; $labels[] = $values[$i][$label_field]; reset($data); foreach($data as $k=>$v) { if (isset($values[$i][$k])) $data[$k]['data'][] = $values[$i][$k]; } } $ctx = '
<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.7.3/Chart.min.js" type="text/javascript"></script>
<div class="card">
<div class="card-header">
<div class="card-title h5">'.$title.'</div>
</div>
<div class="card-body">
<canvas id="'.$name.'_area"></canvas></div></div>
<script type="text/javascript">
//![CDATA[

var cfg_'.$name." = {
	type: 'bar',
	data: {
	    datasets: ["; $need_comma = false; reset($data); foreach($data as $k=>$v) { if ($need_comma) $ctx .= ","; $need_comma = true; $ctx .= "{
	    data :".json_encode($v['data']).",
	    label:'".$v['label']."',
	    backgroundColor: '".$v['color']."'}"; } $ctx .= "],
	    labels: ".json_encode($labels)."
	},
	options: {
	    responsive: true
	}
};

var ctx = document.getElementById('".$name."_area').getContext('2d');
var my_".$name."_Pie = new Chart(ctx, cfg_".$name.");

//]]</script>"; return $ctx; } ?>
